SLASH_COSH1 = '/cosh';
SLASH_COSHM1 = '/coshm';

function SlashCmdList.COSHM()
	if guide then
		guide = false
		GUIDEIMAGEFRAME:Hide()
		print("CoS: guide map disabled")
	else
		guide = true
		if WorldMapFrame:IsVisible() and WorldMapFrame.mapID == 761 then
			if guide then GUIDEIMAGEFRAME:Show(); end
		end
		print("CoS: guide map enabled")
	end
end

function SlashCmdList.COSH(msg)
	if msg=="map" then
		if guide then
			guide = false
			GUIDEIMAGEFRAME:Hide()
			print("CoS: guide map disabled")
		else
			guide = true
			if WorldMapFrame:IsVisible() and WorldMapFrame.mapID == 761 then
				if guide then GUIDEIMAGEFRAME:Show(); end
			end
			print("CoS: guide map enabled")
		end
	end
	if msg=="buffs" then
		if announce then
			announce = false
			print("CoS: buff announcements disabled")
		else
			announce = true
			print("CoS: buff announcements enabled")
		end
	end
	if msg=="spies" then
		if spies then
			spies = false
			print("CoS: spies announcements disabled")
		else
			spies = true
			print("CoS: spies announcements enabled")
		end
	end
end

local npcIDs = {["105117"] = "Alchemist, Rogue [kills Gerdo]", --Flask of the Solemn Night
                ["105157"] = "Engineer, Goblin, Gnome [periodic stun to Constructs]", --Arcane Power Conduit
                ["106110"] = "Shaman, Skinning, Inscription [move speed]", --Waterlogged Scroll
                ["105160"] = "Demon Hunter, Warlock, Priest, Paladin [crit bonus]", --Fel Orb
                ["105340"] = "Druid, Herbalism, Cooking(max?) [haste bonus]", --Umbral Bloom
                ["106018"] = "Rogue, Warrior, Leatherworking [pulls Emissary]", --Bazaar Goods
                ["106112"] = "Healers, Tailors [pulls Emissary]", --Wounded Nightborne Civilian
                ["106113"] = "Jewelcrafting, Mining [pulls Emissary]", --Lifesized Nightborne Statue
                ["105831"] = "Paladin, Priest, Demon Hunter [damage reduction]", --Infernal Tome
                ["105249"] = "Pandaren, Herbalism, Cooking [health bonus]", --Nightshade Refreshments
                ["105215"] = "Hunter, Blacksmithing [pulls and DMG+ to Emissary]", --Discarded Junk
                ["106024"] = "Mage, Enchanting, Elf, Dracthyr [damage bonus]", --Magical Lantern
                ["106108"] = "Death Knight, Monk [regen bonus]" -- Starlight Rose Brew
				} 

local tarIndex = 1
local channel = "SAY"
local lastTriggerTime = 0

local function CoShelper(tooltip, data)
	local mapid,_ = C_Map.GetBestMapForUnit("player")
	if mapid == 761 then
		local npcID = npcIDs[string.sub(data.args[2].guidVal,-17,-12)]
		if npcID then tooltip:AddLine("CoS: "..npcID, 255/255, 106/255, 0/255, true) end
		local currentTime = GetTime()
		if not npcID or (currentTime - lastTriggerTime < 0.4) then return end
		lastTriggerTime = currentTime
		if UnitExists("mouseover") and GetRaidTargetIndex("mouseover") == nil then
			for i=1,9 do
				if not usedTarget(tarIndex) then break end
				tarIndex=tarIndex+1
				if tarIndex > 8 then tarIndex = 1 end;
			end
			SetRaidTargetIcon("mouseover", tarIndex)
			if announce==true then				
				if IsInLFGDungeon() then
					channel = "INSTANCE_CHAT"
				elseif IsInGroup() then
					channel = "PARTY"
				else
					channel = "SAY"
				end
				local mname = GetUnitName("mouseover")
				if mname then SendChatMessage("{rt"..tarIndex.."}"..mname..": "..npcID ,channel ,nil ,"1") end;				
			end
			tarIndex=tarIndex+1
			if tarIndex > 8 then tarIndex = 1 end;
		end				
	end
end
TooltipDataProcessor.AddTooltipPostCall(Enum.TooltipDataType.Unit, CoShelper)

local dummyFrame=CreateFrame("FRAME");
dummyFrame:RegisterEvent("QUEST_LOG_UPDATE");
dummyFrame:RegisterEvent("GOSSIP_SHOW");
dummyFrame:RegisterEvent("ADDON_LOADED");

function usedTarget(tar)
	if GetRaidTargetIndex("player")==tar or GetRaidTargetIndex("pet")==tar or GetRaidTargetIndex("target")==tar or GetRaidTargetIndex("focus")==tar then 
		return true 
	end
	local num = GetNumSubgroupMembers()
	if num > 0 then
		local inUse = false
		for i=1,num do
			local player = "party"..i
			local pet = "partypet"..i
			local playertarget = "party"..i.."target"
			if GetRaidTargetIndex(player)==tar or GetRaidTargetIndex(pet)==tar or GetRaidTargetIndex(playertarget)==tar then 
				print(tar)
				print(UnitName(player))
				return true 
			end
		end
		return false
	end
end

function frameEventHandle(self,event,arg1)
	if arg1=="CoS helper" then
		if announce==nil then announce=true end
		if guide==nil then guide=true end
		if spies==nil then spies=true end
		dummyFrame:UnregisterEvent("ADDON_LOADED");
	end
	if WorldMapFrame:IsVisible() and WorldMapFrame.mapID == 761 and guide then
		GUIDEIMAGEFRAME:Show()
	else
		GUIDEIMAGEFRAME:Hide()
	end
	if event=="GOSSIP_SHOW" and spies and UnitGUID("npc") then
		local guid = string.sub(UnitGUID("npc"),-17,-12)
		if guid and guid=="107486" and GetRaidTargetIndex("npc") == nil then
			if #C_GossipInfo.GetOptions()~=0 then 
				SelectGossipOption(1)
			else
				
				for i=1,9 do
					tarIndex=tarIndex+1
					if tarIndex > 8 then tarIndex = 1 end;
					if not usedTarget(tarIndex) then break end;
				end
				if IsInLFGDungeon() then
					channel = "INSTANCE_CHAT"
				elseif IsInGroup() then
					channel = "PARTY"
				else
					channel = "SAY"
				end
				SendChatMessage("CoS: {rt"..tarIndex.."}"..C_GossipInfo.GetText() ,channel ,nil ,"1")
				SetRaidTarget("target", tarIndex)				
			end
		end
	end
	if event=="GOSSIP_SHOW" and UnitGUID("npc") then
		local guid = string.sub(UnitGUID("npc"),-17,-12)
		if guid and npcIDs[guid] and #C_GossipInfo.GetOptions()~=0 then SelectGossipOption(1) end
	end
end
dummyFrame:SetScript("OnEvent",frameEventHandle)
WorldMapFrame:HookScript("OnHide",frameEventHandle)

GUIDEIMAGEFRAME = CreateFrame("Frame",ShowUF,UIParent)
GUIDEIMAGEFRAME.ufTexture = GUIDEIMAGEFRAME:CreateTexture()
GUIDEIMAGEFRAME.ufTexture:SetTexture("Interface\\AddOns\\CoS helper\\guide")
GUIDEIMAGEFRAME.ufTexture:SetPoint("TOPLEFT", WorldMapFrame, "BOTTOMLEFT")
GUIDEIMAGEFRAME.ufTexture:SetSize(480,480)
GUIDEIMAGEFRAME:SetPoint("TOPLEFT", WorldMapFrame, "BOTTOMLEFT")
GUIDEIMAGEFRAME:SetSize(480,480)

GUIDEIMAGEFRAME:SetScript("OnMouseUp", function(_,btn)
	if btn=="RightButton" then 
		guide=false
		print("CoS: guide map disabled. Enable with /coshm")
		GUIDEIMAGEFRAME:Hide()
	end
end)